#!/usr/bin/perl

# Two modes:
#   1. ./clean.pl      : list files that are not part of the clean directory
#   2. ./clean.pl -rm  : erases all files other than
#                        those in the list of expected
#                        files for the directory in its clean state
#                        (Except it leaves Report/ behind too)

@goodfiles = (
  "clean.pl",
  "compile.sh",
  "header1.html",
  "mkreport.pl",
  "README.txt",
  "run.sh",
  "Report",
);

cleanup_files_otherthan(\@ARGV, @goodfiles);

sub cleanup_files_otherthan {
  my @argv = @{shift @_};
  my @goodfiles = @_;
  my $file;
  my $goodfile;
  my $isgood;
  my $erase;
  my $arg;

  $erase = 0;
  for $arg (@argv) {
    if ($arg eq "-rm") {
      $erase = 1;
    }
  }
  if ($erase) {
    print "ERASING extra files:\n";
  } else {
    print "Listing extra files (use -rm to auto-erase):\n";
  }

  opendir UTILDIR, ".";
  while ($file = readdir UTILDIR) {
    if (! ($file =~ /[A-Za-z0-9]/)) { next; } # Just for safety

    $isgood = 0;
    for $goodfile (@goodfiles) {
      if ($file eq $goodfile) {
        $isgood = 1;
      }
    }
    if (! $isgood) {
      print "  $file\n";
      if ($erase) { system "rm -rf $file"; }
    }
  }
  closedir UTILDIR;
}
