#!/bin/bash

# Given input values for the environment variables
#   1. MPI_ROOT (for example: /opt/ibm/spectrum_mpi)
#   2. OMPI_FC  (for example: gfortran, ifort, etc)
# this script creates a mpi.mod fortran module in the current directory.

echo "Building ./mpi.mod using"
echo "  MPI_ROOT=$MPI_ROOT"
echo "  OMPI_FC=$OMPI_FC"

if [ -z "${MPI_ROOT:-}" -o -z "${OMPI_FC:-}" ] ; then
    echo "Error: MPI_ROOT and OMPI_FC settings required."
    exit 1
fi

$OMPI_FC -DHAVE_CONFIG_H \
    -I$MPI_ROOT/lib/module -I$MPI_ROOT/include \
    -c -o mpi.lo $MPI_ROOT/lib/module/mpi.F90
